/* 
 * (c) Copyright 1989, 1990, 1991, 1992, 1993 OPEN SOFTWARE FOUNDATION, INC. 
 * ALL RIGHTS RESERVED 
*/ 
/* 
 * Motif Release 1.2.3
*/ 
/*   $RCSfile: FormP.h,v $ $Revision: 10.1 $ $Date: 1994/02/03 15:40:12 $ */
/*
*  (c) Copyright 1989, DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS. */
/*
*  (c) Copyright 1987, 1988, 1989, 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */

/*
 *  _ __ ___ _
 * | |\ /  /| |
 * | | /  / | |  Copyright (C) 1988-1992 IXI Limited.
 * |_|/__/_\|_|  IXI Limited, Cambridge, England.
 *
 *  @(#) FormP.h vsn 8.2 93/02/18 13:45:39
 *
 *  Program       : 
 *  Module        : Form.c
 *  Author        : Gary Henderson + OSF Team
 *  Description   : Motif Form widget private header file
 *
 * Mod for M1.2.1 beta - add c++ bindings
 */


#ifndef _XmFormP_h
#define _XmFormP_h

#ifdef __cplusplus
extern "C" {
#endif

#include <Xm/BulletinBP.h>
#include <Xm/Form.h>

#ifndef XmRWidget
#define XmRWidget "Widget"
#endif

#define SORTED_LEFT_TO_RIGHT 	(1 << 0)
#define SORTED_TOP_TO_BOTTOM 	(1 << 1)
#define DONT_USE_BOTTOM 	(1 << 2)
#define DONT_USE_RIGHT 		(1 << 3)
#define WIDGET_DONT_USE_BOTTOM 	(1 << 4)
#define WIDGET_DONT_USE_RIGHT 	(1 << 5)
#define LEFT_NOT_MOVABLE 	(1 << 6)
#define RIGHT_NOT_MOVABLE 	(1 << 7)
#define TOP_NOT_MOVABLE 	(1 << 8)
#define BOTTOM_NOT_MOVABLE 	(1 << 9)
#define NOT_MOVABLE_RIGHT 	(1 << 10)
#define NOT_MOVABLE_DOWN 	(1 << 11)
#define DONT_ATTEMPT_MOVE_RIGHT (1 << 12)
#define DONT_ATTEMPT_MOVE_DOWN  (1 << 13)

typedef struct _XmFormAttachmentRec
{
    unsigned char   type;
    Widget          w;
    int             percent;
    int             offset;
    int             value;
    /* OSF fields */
    int             tempValue;
} XmFormAttachmentRec, *XmFormAttachment;

typedef struct _XmFormConstraintPart
{
    XmFormAttachmentRec att[4];
    Widget          next_siblings[2];
    int             flags;
    XtWidgetGeometry geom;
    Boolean         resizable;
    /* OSF fields */
    Widget          next_sibling;
    Boolean         sorted;
    Dimension       preferred_width, preferred_height;
} XmFormConstraintPart, *XmFormConstraint;

typedef struct _XmFormConstraintRec
{
    XmManagerConstraintPart manager;
    XmFormConstraintPart form;
} XmFormConstraintRec, *XmFormConstraintPtr;


/* Form class structure  */

typedef struct _XmFormClassPart
{
   XtPointer extension;   /* Pointer to extension record */
} XmFormClassPart;


/* Full class record declaration for form class  */

typedef struct _XmFormClassRec
{
    CoreClassPart   core_class;
    CompositeClassPart composite_class;
    ConstraintClassPart constraint_class;
    XmManagerClassPart manager_class;
    XmBulletinBoardClassPart bulletin_board_class;
    XmFormClassPart form_class;
} XmFormClassRec;

extern XmFormClassRec xmFormClassRec;


/* The Form instance record  */

typedef struct _XmFormPart
{
    Dimension       horizontal_spacing;
    Dimension       vertical_spacing;
    int             fraction_base;
    Boolean         rubber_positioning;
    Boolean         need_sorting;
    Widget          sorted_children [2];
    /* OSF fields */
    Widget          first_child;
    Boolean initial_width, initial_height;
    Boolean processing_constraints;
} XmFormPart;


/* Full instance record declaration  */

typedef struct _XmFormRec
{
    CorePart        core;
    CompositePart   composite;
    ConstraintPart  constraint;
    XmManagerPart   manager;
    XmBulletinBoardPart bulletin_board;
    XmFormPart      form;
} XmFormRec;

#define FORM_MAGIC (('I' << 8) | ('X' << 8))
#define XmFormIsDelayedConversion(x) (((XmFormDelayedConversion) (x))->magic == FORM_MAGIC)

typedef struct
{
    unsigned int    magic;
    String	    name;
} *XmFormDelayedConversion, XmFormDelayedConversionRec;


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif				/* _XmFormP_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
